import * as i0 from '@angular/core';
import { Injectable, Component, Input, ViewChild, NgModule } from '@angular/core';
import { DomSanitizer } from '@angular/platform-browser';

class SearchHighlighterService {
    constructor() { }
}
SearchHighlighterService.ɵprov = i0.ɵɵdefineInjectable({ factory: function SearchHighlighterService_Factory() { return new SearchHighlighterService(); }, token: SearchHighlighterService, providedIn: "root" });
SearchHighlighterService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
SearchHighlighterService.ctorParameters = () => [];

class SearchHighlighterComponent {
    constructor(sanitizer) {
        this.sanitizer = sanitizer;
        this.color = 'yellow'; // default yellow color
        this.query = '';
    }
    ngOnInit() {
        var _a, _b;
        // gets text from original content 
        this.replacedInputText = (_b = (_a = this.inputs) === null || _a === void 0 ? void 0 : _a.nativeElement) === null || _b === void 0 ? void 0 : _b.innerText;
    }
    /**
     * research on any changes in query/color
     */
    ngOnChanges() {
        this.search();
    }
    search() {
        var _a, _b, _c;
        // replacing the original content
        this.replacedInputText = this.sanitizer.bypassSecurityTrustHtml((_c = (_b = (_a = this.inputs) === null || _a === void 0 ? void 0 : _a.nativeElement) === null || _b === void 0 ? void 0 : _b.innerText) === null || _c === void 0 ? void 0 : _c.replace(new RegExp(this.query, 'g'), 
        // Using Color Code
        `<span style="background-color:${this.color}">${this.query}</span>`));
    }
}
SearchHighlighterComponent.decorators = [
    { type: Component, args: [{
                selector: 'gt-search-highlighter',
                template: "<!-- ORIGINAL CONTENT : hide original and display highlighted in below one -->\r\n<div #inputs [hidden]='true'>\r\n  <ng-content></ng-content>\r\n</div>\r\n  \r\n<!-- REPLACED CONTENT -->\r\n<div class=\"gt-hl\" [innerHtml]='replacedInputText'></div>"
            },] }
];
SearchHighlighterComponent.ctorParameters = () => [
    { type: DomSanitizer }
];
SearchHighlighterComponent.propDecorators = {
    color: [{ type: Input }],
    query: [{ type: Input }],
    inputs: [{ type: ViewChild, args: ['inputs', { static: true },] }]
};

class SearchHighlighterModule {
}
SearchHighlighterModule.decorators = [
    { type: NgModule, args: [{
                declarations: [SearchHighlighterComponent],
                imports: [],
                exports: [SearchHighlighterComponent]
            },] }
];

/*
 * Public API Surface of search-highlighter
 */

/**
 * Generated bundle index. Do not edit.
 */

export { SearchHighlighterComponent, SearchHighlighterModule, SearchHighlighterService };
//# sourceMappingURL=bluerdanblue-search-highlighter.js.map
